import { Action, History, Location, UnregisterCallback } from 'history';
import { Key, Path as RegPath } from 'path-to-regexp';
import { Model, Store } from '@redux-model/react';
export declare type RouterLocation = Location;
export declare type RouterAction = Action;
interface Data {
    location: RouterLocation;
    action: RouterAction;
}
declare type Subscriber = {
    path: RegPath | object;
    reg?: RegExp;
    keys?: Key[];
    fn: Function;
    token: string;
};
export declare abstract class RouterModel extends Model<Data> {
    protected isInitialized: boolean;
    protected unregister: UnregisterCallback | undefined;
    protected pathListeners: Array<Subscriber>;
    protected readonly customHistory?: History;
    constructor(history?: History);
    protected readonly changeHistory: ((payload: Data) => import("@redux-model/core").IActionNormal<Data, Data>) & import("@redux-model/core").NormalAction<Data, (_: import("@redux-model/core").State<Data>, payload: Data) => Data, Data, (action: import("@redux-model/core").IActionPayload<Data, string>) => void>;
    go: (index: number) => void;
    goBack: () => void;
    goForward: () => void;
    listenPath<Params = Record<string, string>>(path: RegPath, fn: (params: Params, location: RouterLocation, action: RouterAction) => void): string;
    listenAll(fn: (location: RouterLocation, action: RouterAction) => void): string;
    unlisten(token?: string): void;
    getHistory(): History;
    protected publishAll(location: RouterLocation, action: RouterAction): void;
    protected publishOne(subscriber: Subscriber, location: RouterLocation, action: RouterAction): any;
    protected onStoreCreated(store: Store): void;
    protected initialState(): Data;
    protected abstract createHistory(): History;
}
export {};
